'FEM計算の実行ﾌﾟﾛｸﾞﾗﾑ（ｽｶｲﾗｲﾝ法）
'縮小ﾏﾄﾘｯｸｽ方式採用
Imports System.Drawing

Public Class CompFEM3Cal5
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(240, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "構造解析計算の実行（スカイライン法）"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.AutoSize = True
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(38, 12)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(144, 192)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(136, 24)
        Me.PictureBox1.TabIndex = 3
        Me.PictureBox1.TabStop = False
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(144, 136)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(260, 24)
        Me.PictureBox2.TabIndex = 4
        Me.PictureBox2.TabStop = False
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 248)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(400, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'CompFEM3Cal5
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.Add(Me.ProgressBar1)
        Me.Controls.Add(Me.PictureBox2)
        Me.Controls.Add(Me.PictureBox1)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.Name = "CompFEM3Cal5"
        Me.Text = "CompFEM3Cal5"
        CType(Me.PictureBox1, System.ComponentModel.ISupportInitialize).EndInit()
        CType(Me.PictureBox2, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    Dim SwK As IO.StreamWriter  '結果出力用

    Dim Nbound As Integer       '拘束の全節点数
    Dim NBvar As Integer        '固定の変数の数
    Dim Neff As Integer         '縮小ﾏﾄﾘｯｸｽの行列数
    Dim NumEff As Integer       'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置

    Dim Idiag() As Integer      '改良順FEM行列(ｽｶｲﾗｲﾝ)対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim Jdirect(,) As Integer   '拘束全節点の各軸方向拘束有無(0:非拘束、1:拘束）
    Dim KBfix() As Integer      '固定の変数番号
    Dim KDispMax(6) As Integer  '最大変位の節点番号
    Dim KStMax(10) As Integer   '最大応力の節点番号

    Dim KEfmax() As Integer         '変位・軸力等最大の要素番号
    Dim KEfmin() As Integer         '変位・軸力等最小の要素番号
    Dim KPfmax() As Integer         '変位・軸力等最大の節点番号
    Dim KPfmin() As Integer         '変位・軸力等最小の節点番号

    Dim Nrest() As Integer      '拘束の全節点番号
    Dim Nw() As Integer         '各節点の共通要素数

    Dim B(,) As Double          'Bﾏﾄﾘｯｸｽ
    Dim D(,) As Double          'Dﾏﾄﾘｯｸｽ
    Dim Db(,) As Double         'DBﾏﾄﾘｯｸｽ
    Dim DispMax(6) As Single    '最大変位
    Dim Eu() As Double          '節点変位
    Dim Sgaus(,) As Double      '要素計算のｶﾞｳｽ点応力
    Dim Spoint(,) As Double     '要素計算の節点応力
    Dim StMax(10) As Single     '最大応力
    Dim Tk() As Double          'FEM行列
    Dim Tp(,) As Double         '節点応力累積値
    Dim Tr(20, 27) As Single    '節点応力計算ﾏﾄﾘｯｸｽ
    Dim VBfix() As Double       '変数固定値
    Dim Vdirect(,) As Single    '拘束全節点の各変位方向拘束値

    Dim Zfmax() As Single           '変位・軸力等の最大値
    Dim Zfmin() As Single           '変位・軸力等の最小値

    Private Sub BForceCalc()
        '拘束境界の反力計算
        Dim aa$
        Dim i, ib, id, ie, ii, ip, j, jj, k, kb, ndimb, nmax, nvarb As Integer
        Dim b1 As Single
        Dim ey, rnu As Double
        Dim buf(6), tfb(60), zbuf(60) As Single

        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 拘束境界の節点反力 ＊＊")
        aa$ = "＜節点番号、Ｆx、Ｆy、Ｆz、Ｍx、Ｍy、Ｍz＞"
        SwK.WriteLine(aa$)

        kb = 0
        For ib = 1 To Nbound
            For i = 1 To 6
                buf(i) = 0
            Next i
            ii = Nrest(ib)
            For ie = 1 To NelemC
                Select Case KindEC(ie)
                    Case 0
                        nmax = 20
                        ndimb = 3
                        nvarb = 60
                    Case 1
                        nmax = 2
                        ndimb = 3
                        nvarb = 6
                    Case Else
                        nmax = 2
                        ndimb = 6
                        nvarb = 12
                End Select
                k = 0
                For j = 1 To nmax
                    If NNelemC(ie, j) = ii Then
                        k = j
                        Exit For
                    End If
                Next j
                If k > 0 Then
                    jj = 0
                    For j = 1 To nmax
                        ip = NNelemC(ie, j)
                        i = NvarPSum(Kcomp(ip) - 1)
                        For id = 1 To ndimb
                            jj = jj + 1
                            kb = Lcomp(i + id)
                            If kb > 0 Then
                                zbuf(jj) = Tf(kb)
                            End If
                        Next id
                    Next j
                    If KindEC(ie) = 0 Then
                        Call ElemMatrix2(ie, kb, ey, rnu, zbuf)      '要素ﾏﾄﾘｯｸｽの計算
                        For i = 2 To 60
                            For j = 1 To i - 1
                                Ek(i, j) = Ek(j, i)
                            Next j
                        Next i
                    Else
                        Call ElemMatrixBar2(ie)      '要素ﾏﾄﾘｯｸｽの計算（部材）
                    End If
                    For i = 1 To nvarb
                        b1 = 0
                        For j = 1 To nvarb
                            b1 = b1 + Ek(i, j) * zbuf(j)
                        Next j
                        tfb(i) = b1
                    Next i
                    j = ndimb * (k - 1)
                    For i = 1 To ndimb
                        j = j + 1
                        buf(i) = buf(i) + tfb(j)
                    Next i
                End If
            Next ie
            aa$ = Str(ii)
            For i = 1 To 6
                If Jdirect(ib, i) = 0 Then
                    buf(i) = 0
                End If
                aa$ = aa$ + ",  " + Str(buf(i))
            Next i
            SwK.WriteLine(aa$)
        Next ib

    End Sub

    Private Sub BMatrix()
        '変位を歪に変換するﾏﾄﾘｯｸｽの計算
        Dim i, ii, isb, j As Integer
        For isb = 1 To 6
            For i = 1 To 60
                B(isb, i) = 0
            Next i
        Next isb
        For ii = 1 To 20
            j = 3 * (ii - 1)
            B(1, j + 1) = Dx(ii)
            B(2, j + 2) = Dy(ii)
            B(3, j + 3) = Dz(ii)
            B(4, j + 1) = Dy(ii)
            B(4, j + 2) = Dx(ii)
            B(5, j + 2) = Dz(ii)
            B(5, j + 3) = Dy(ii)
            B(6, j + 1) = Dz(ii)
            B(6, j + 3) = Dx(ii)
        Next ii

    End Sub

    Private Sub CoeffMatrix(ByVal ie As Integer, ByVal istage As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･ｶﾞｳｽ点応力計算の有無（0:なし、1:有り）
        Dim i, id, ig, ii, isb, j, jg, kg, kkg, numg As Integer
        Dim dj, dv, s, t, u As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    Call BMatrix()
                    For isb = 1 To 6
                        For i = 1 To 60
                            Db(isb, i) = 0
                            For j = 1 To 6
                                Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                            Next j
                        Next i
                        If istage > 0 Then
                            Sgaus(numg, isb) = 0 : kkg = 0
                            For ii = 1 To 20
                                For id = 1 To 3
                                    kkg = kkg + 1
                                    Sgaus(numg, isb) = Sgaus(numg, isb) + Db(isb, kkg) * Eu(kkg)
                                Next id
                            Next ii
                        End If
                    Next isb

                    If istage = 0 Then
                        For i = 1 To 60
                            For j = i To 60
                                For isb = 1 To 6
                                    Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * dv
                                Next isb
                            Next j
                        Next i

                        'Else
                        '    a1$ = "ｶﾞｳｽ点"
                        '    a2$ = "XG="
                        '    a3$ = "YG="
                        '    a4$ = "ZG="
                        '    z1 = XG(numg)
                        '    z2 = YG(numg)
                        '    z3 = ZG(numg)
                        '    Write #Kfile, a1$, numg, a2$, z1, a3$, z2, a4$, z3
                        '    sx = Sgaus(numg, 1)
                        '    sy = Sgaus(numg, 2)
                        '    sz = Sgaus(numg, 3)
                        '    txy = Sgaus(numg, 4)
                        '    tyz = Sgaus(numg, 5)
                        '    tzx = Sgaus(numg, 6)
                        '    Call StressOut(sx, sy, sz, txy, tyz, tzx)
                        '応力値の出力
                    End If
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub CoeffMatrix2(ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算2
        'ie･･･要素番号
        Dim i, ig, isb, j, jg, kg, numg As Integer
        Dim dj, dv, s, t, u As Double
        numg = 0
        For ig = 1 To Ngaus
            s = PosGaus(ig)
            For jg = 1 To Ngaus
                t = PosGaus(jg)
                For kg = 1 To Ngaus
                    numg = numg + 1
                    u = PosGaus(kg)
                    Call ShapeFunc(1, s, t, u)         '形状関数の計算
                    Call JacobElem(ie, 0, numg, dj)   '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                    dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                    Call BMatrix()
                    For isb = 1 To 6
                        For i = 1 To 60
                            Db(isb, i) = 0
                            For j = 1 To 6
                                Db(isb, i) = Db(isb, i) + D(isb, j) * B(j, i)
                            Next j
                        Next i
                    Next isb

                    For i = 1 To 60
                        For j = i To 60
                            For isb = 1 To 6
                                Ek(i, j) = Ek(i, j) + B(isb, i) * Db(isb, j) * dv
                            Next isb
                        Next j
                    Next i
                Next kg
            Next jg
        Next ig

    End Sub

    Private Sub CoeffMatrixBar(ByVal istage As Integer, ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算（部材）
        'istage･･･応力計算の有無（0:なし、1:有り）
        'ie･･･要素番号
        Dim ib, j, k, kp, nvarb As Integer
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, csb, e, g As Double
        Dim riy, riz, rlen, rlen2, rlen3, rnyu, s, ud As Double

        kp = NumMatC(ie)
        e = DataMatC(kp, 1)
        rnyu = DataMatC(kp, 2)
        ud = DataMatC(kp, 3)
        area = DataMatC(kp, 4)
        riy = DataMatC(kp, 5)
        riz = DataMatC(kp, 6)
        csb = DataMatC(kp, 7)
        g = e / (2 * (1 + rnyu))

        rlen = RlenBar(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2
        c1 = e * area / rlen
        c2 = 12 * e * riz / rlen3
        c3 = 6 * e * riz / rlen2
        c4 = 12 * e * riy / rlen3
        c5 = 6 * e * riy / rlen2
        c6 = g * csb / rlen
        c7 = 4 * e * riy / rlen
        c8 = 4 * e * riz / rlen

        Select Case KindEC(ie)
            Case 1
                nvarb = 6
                Ek(1, 1) = c1 : Ek(1, 4) = -c1
                Ek(4, 1) = -c1 : Ek(4, 4) = c1
            Case 2
                nvarb = 12
                Ek(1, 1) = c1 : Ek(1, 7) = -c1 : Ek(7, 1) = -c1
                Ek(2, 2) = c2 : Ek(2, 6) = c3 : Ek(6, 2) = c3
                Ek(2, 8) = -c2 : Ek(8, 2) = -c2 : Ek(2, 12) = c3 : Ek(12, 2) = c3
                Ek(3, 3) = c4 : Ek(3, 5) = -c5 : Ek(5, 3) = -c5
                Ek(3, 9) = -c4 : Ek(9, 3) = -c4 : Ek(3, 11) = -c5 : Ek(11, 3) = -c5
                Ek(4, 4) = c6 : Ek(4, 10) = -c6 : Ek(10, 4) = -c6
                Ek(5, 5) = c7 : Ek(5, 9) = c5 : Ek(9, 5) = c5
                Ek(5, 11) = 0.5 * c7 : Ek(11, 5) = 0.5 * c7
                Ek(6, 6) = c8 : Ek(6, 8) = -c3 : Ek(8, 6) = -c3
                Ek(6, 12) = 0.5 * c8 : Ek(12, 6) = 0.5 * c8
                Ek(7, 7) = c1
                Ek(8, 8) = c2 : Ek(8, 12) = -c3 : Ek(12, 8) = -c3
                Ek(9, 9) = c4 : Ek(9, 11) = c5 : Ek(11, 9) = c5
                Ek(10, 10) = c6 : Ek(11, 11) = c7 : Ek(12, 12) = c8
        End Select

        For ib = 1 To nvarb
            For j = 1 To nvarb
                s = 0
                For k = 1 To nvarb
                    s = s + Ek(ib, k) * Trans(k, j)
                Next k
                Ekb(ib, j) = s
            Next j
        Next ib

        If istage = 0 Then
            For ib = 1 To nvarb
                For j = 1 To nvarb
                    s = 0
                    For k = 1 To nvarb
                        s = s + Trans(k, ib) * Ekb(k, j)
                    Next k
                    Ek(ib, j) = s
                Next j
            Next ib
        End If

    End Sub

    Private Sub CoeffMatrixBar2(ByVal istage As Integer, ByVal ie As Integer)
        '各要素の係数ﾏﾄﾘｯｸｽの計算（部材混合）
        'istage･･･応力計算の有無（0:なし、1:有り）
        'ie･･･要素番号
        Dim ib, j, k, kc, kp As Integer
        Dim cb As Single
        Dim area, c1, c2, c3, c4, c5, c6, c7, c8, csb, e, g As Double
        Dim riy, riz, rlen, rlen2, rlen3, rnyu, s, ud As Double

        cb = 1.0 - CrateA
        kc = KindEC(ie)
        kp = NumMatC(ie)
        e = DataMatC(kp, 1)
        rnyu = DataMatC(kp, 2)
        ud = DataMatC(kp, 3)
        area = DataMatC(kp, 4)
        riy = DataMatC(kp, 5)
        riz = DataMatC(kp, 6)
        csb = DataMatC(kp, 7)
        g = e / (2 * (1 + rnyu))

        rlen = RlenBar(ie)
        rlen2 = rlen * rlen
        rlen3 = rlen * rlen2
        c1 = e * area / rlen
        c6 = g * csb / rlen
        If kc = 2 Then
            c2 = 12 * e * riz / rlen3
            c3 = 6 * e * riz / rlen2
            c4 = 12 * e * riy / rlen3
            c5 = 6 * e * riy / rlen2
            c7 = 4 * e * riy / rlen
            c8 = 4 * e * riz / rlen
        Else
            c2 = 3 * e * riz / rlen3
            c3 = 3 * e * riz / rlen2
            c4 = 3 * e * riy / rlen3
            c5 = 3 * e * riy / rlen2
            c7 = 3 * e * riy / rlen
            c8 = 3 * e * riz / rlen
        End If

        Ek(1, 1) = c1 : Ek(1, 7) = -c1
        Ek(7, 1) = -c1 : Ek(7, 7) = c1
        Select Case kc
            Case 3
                Ek(2, 2) = c2 : Ek(2, 8) = -c2 : Ek(2, 12) = c3
                Ek(3, 3) = c4 : Ek(3, 9) = -c4 : Ek(3, 11) = -c5
                Ek(8, 2) = -c2 : Ek(8, 8) = c2 : Ek(8, 12) = -c3
                Ek(9, 3) = -c4 : Ek(9, 9) = c4 : Ek(9, 11) = c5
                Ek(11, 3) = -c5 : Ek(11, 9) = c5 : Ek(11, 11) = c7
                Ek(12, 2) = c3 : Ek(12, 8) = -c3 : Ek(12, 12) = c8
            Case 4
                Ek(2, 2) = c2 : Ek(2, 6) = c3 : Ek(2, 8) = -c2
                Ek(3, 3) = c4 : Ek(3, 5) = -c5 : Ek(3, 9) = -c4
                Ek(5, 3) = -c5 : Ek(5, 5) = c7 : Ek(5, 9) = c5
                Ek(6, 2) = c3 : Ek(6, 6) = c8 : Ek(6, 8) = -c3
                Ek(8, 2) = -c2 : Ek(8, 6) = -c3 : Ek(8, 8) = c2
                Ek(9, 3) = -c4 : Ek(9, 5) = c5 : Ek(9, 9) = c4
        End Select
        c2 = 12 * e * riz / rlen3
        c3 = 6 * e * riz / rlen2
        c4 = 12 * e * riy / rlen3
        c5 = 6 * e * riy / rlen2
        c7 = 4 * e * riy / rlen
        c8 = 4 * e * riz / rlen
        Ek(2, 2) = cb * Ek(2, 2) + CrateA * c2
        Ek(2, 6) = cb * Ek(2, 6) + CrateA * c3
        Ek(6, 2) = Ek(2, 6)
        Ek(2, 8) = cb * Ek(2, 8) - CrateA * c2
        Ek(8, 2) = Ek(2, 8)
        Ek(2, 12) = cb * Ek(2, 12) + CrateA * c3
        Ek(12, 2) = Ek(2, 12)
        Ek(3, 3) = cb * Ek(3, 3) + CrateA * c4
        Ek(3, 5) = cb * Ek(3, 5) - CrateA * c5
        Ek(5, 3) = Ek(3, 5)
        Ek(3, 9) = cb * Ek(3, 9) - CrateA * c4
        Ek(9, 3) = Ek(3, 9)
        Ek(3, 11) = cb * Ek(3, 11) - CrateA * c5
        Ek(11, 3) = Ek(3, 11)
        Ek(4, 4) = CrateA * c6
        Ek(4, 10) = -CrateA * c6
        Ek(10, 4) = Ek(4, 10)
        Ek(5, 5) = cb * Ek(5, 5) + CrateA * c7
        Ek(5, 9) = cb * Ek(5, 9) + CrateA * c5
        Ek(9, 5) = Ek(5, 9)
        Ek(5, 11) = CrateA * 0.5 * c7
        Ek(11, 5) = Ek(5, 11)
        Ek(6, 6) = cb * Ek(6, 6) + CrateA * c8
        Ek(6, 8) = cb * Ek(6, 8) - CrateA * c3
        Ek(8, 6) = Ek(6, 8)
        Ek(6, 12) = cb * Ek(6, 12) + CrateA * 0.5 * c8
        Ek(12, 6) = Ek(6, 12)
        Ek(8, 8) = cb * Ek(8, 8) + CrateA * c2
        Ek(8, 12) = cb * Ek(8, 12) - CrateA * c3
        Ek(12, 8) = Ek(8, 12)
        Ek(9, 9) = cb * Ek(9, 9) + CrateA * c4
        Ek(9, 11) = cb * Ek(9, 11) + CrateA * c5
        Ek(11, 9) = Ek(9, 11)
        Ek(10, 10) = CrateA * c6
        Ek(11, 11) = cb * Ek(11, 11) + CrateA * c7
        Ek(12, 12) = cb * Ek(12, 12) + CrateA * c8

        For ib = 1 To 12
            For j = 1 To 12
                s = 0
                For k = 1 To 12
                    s = s + Ek(ib, k) * Trans(k, j)
                Next k
                Ekb(ib, j) = s
            Next j
        Next ib

        If istage = 0 Then
            For ib = 1 To 12
                For j = 1 To 12
                    s = 0
                    For k = 1 To 12
                        s = s + Trans(k, ib) * Ekb(k, j)
                    Next k
                    Ek(ib, j) = s
                Next j
            Next ib
        End If

    End Sub

    Private Sub Debug1(ByVal mh As Integer, ByVal nx As Integer)
        '剛性ﾏﾄﾘｯｸｽを出力して停止
        '非0要素のみ出力
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, fxx$
        Dim i, ic, j, j2, ii, kx As Integer
        Dim z1 As Single
        ii = FreeFile()
        fxx$ = DirOpen$ + "\FEM3debug1.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜剛性マトリックスデータ＞＞"
        WriteLine(ii, aa$)
        For i = 1 To nx
            aa$ = "行" + Str$(i)
            WriteLine(ii, aa$)
            j2 = i + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            ic = 0
            For j = i To j2
                kx = Idiag(j) - (j - i)
                If kx > Idiag(j - 1) Then
                    z1 = Tk(kx)
                    If z1 <> 0 Then
                        If ic = 0 Then
                            aa$ = Str$(j) + ",  " + Str$(z1)
                        Else
                            aa$ = aa$ + ",    " + Str$(j) + ",  " + Str$(z1)
                        End If
                        If ic = 4 Then
                            PrintLine(ii, aa$)
                            ic = 0
                        Else
                            ic = ic + 1
                        End If
                    End If
                End If
            Next j
            If ic > 0 Then
                PrintLine(ii, aa$)
            End If
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug2(ByVal n1 As Integer, ByVal n2 As Integer)
        'Tfﾍﾞｸﾄﾙを出力して停止
        'n1･･･開始変数番号
        'n2･･･終了変数番号
        Dim aa$, fxx$
        Dim i, id, ii As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\FEM3debug2.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "Tfﾍﾞｸﾄﾙ"
        WriteLine(ii, aa$)
        id = 0
        aa$ = ""
        For i = n1 To n2
            aa$ = aa$ + "  " + Str(i) + ",  " + Str(Tf(i))
            If id = 4 Then
                PrintLine(ii, aa$)
                id = 0
                aa$ = ""
            Else
                id = id + 1
            End If
        Next i
        If id > 0 Then
            PrintLine(ii, aa$)
        End If
        FileClose(ii)
        Stop
    End Sub

    Private Sub DebugEK(ByVal ie As Integer, ByVal nx As Integer)
        '要素ﾏﾄﾘｯｸｽを出力して停止
        'ie･･･要素番号
        'nx･･･変数の数
        Dim aa$, fdebug$
        Dim i, id, ii, j As Integer

        aa$ = ""
        ii = FreeFile()
        fdebug$ = DirOpen$ + "\CompFEM3Cal5Ddebug.dat"
        FileOpen(ii, fdebug$, OpenMode.Output)
        WriteLine(ii, "＜要素マトリックス＞")
        WriteLine(ii, "要素番号", ie)
        For i = 1 To nx
            aa$ = "行" + Str(i)
            WriteLine(ii, aa$)
            id = 0
            For j = 1 To nx
                If id = 0 Then
                    aa$ = Str(Ek(i, j))
                Else
                    aa$ = aa$ + ",  " + Str(Ek(i, j))
                End If
                If id = 4 Then
                    PrintLine(ii, aa$)
                    id = 0
                Else
                    id = id + 1
                End If
            Next j
            If id <> 0 Then
                PrintLine(ii, aa$)
            End If
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer,
        ByRef kb As Integer, ByRef e As Double, ByRef rnu As Double)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･ｶﾞｳｽ点応力計算の有無（0:なし、1:有り）
        'kb･･･材料番号
        'e･･･ﾔﾝｸﾞ率
        'rnu･･･ﾎﾟｱｿﾝ比
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, id, ii, j, k, kp As Integer
        Dim b0, b1, b2, b3 As Double

        kp = NumMatC(ie)
        If kp <> kb Then
            For i = 1 To 6
                For j = 1 To 6
                    D(i, j) = 0
                Next j
            Next i
            kb = kp
            e = DataMatC(kp, 1)
            rnu = DataMatC(kp, 2)

            '歪から応力を換算するﾏﾄﾘｯｸｽ成分の計算
            b0 = e / ((1 + rnu) * (1 - 2 * rnu))
            b1 = b0 * (1 - rnu)
            b2 = b0 * rnu
            b3 = e / (2 * (1 + rnu))
            D(1, 1) = b1 : D(2, 2) = b1 : D(3, 3) = b1
            D(1, 2) = b2 : D(1, 3) = b2
            D(2, 1) = b2 : D(2, 3) = b2
            D(3, 1) = b2 : D(3, 2) = b2
            D(4, 4) = b3 : D(5, 5) = b3 : D(6, 6) = b3
        End If

        For i = 1 To 60
            For j = i To 60
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 20
            i = NNelemC(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            k = NvarPSum(Kcomp(i) - 1)
            For id = 1 To 3
                j = j + 1
                k = k + 1
                NPrefer(j) = Lcomp(k)
                If KindDPL > 0 Then
                    b1 = Tfx(Lcomp(k))
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + b1
                        Case 2
                            YE(ii) = YE(ii) + b1
                        Case 3
                            ZE(ii) = ZE(ii) + b1
                    End Select
                End If
            Next id
        Next ii

        Call CoeffMatrix(ie, istage)   '各要素の係数ﾏﾄﾘｯｸｽの計算

        'Call DebugEK(ie, 60)

    End Sub

    Private Sub ElemMatrix2(ByVal ie As Integer, ByRef kb As Integer, _
        ByRef e As Double, ByRef rnu As Double, ByVal zbuf() As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kb･･･材料番号
        'e･･･ﾔﾝｸﾞ率
        'rnu･･･ﾎﾟｱｿﾝ比
        'zbuf()･･･節点変位
        Dim i, id, ii, j, kp As Integer
        Dim b0, b1, b2, b3 As Double

        kp = NumMatC(ie)
        If kp <> kb Then
            For i = 1 To 6
                For j = 1 To 6
                    D(i, j) = 0
                Next j
            Next i
            kb = kp
            e = DataMatC(kp, 1)
            rnu = DataMatC(kp, 2)

            '歪から応力を換算するﾏﾄﾘｯｸｽ成分の計算
            b0 = e / ((1 + rnu) * (1 - 2 * rnu))
            b1 = b0 * (1 - rnu)
            b2 = b0 * rnu
            b3 = e / (2 * (1 + rnu))
            D(1, 1) = b1 : D(2, 2) = b1 : D(3, 3) = b1
            D(1, 2) = b2 : D(1, 3) = b2
            D(2, 1) = b2 : D(2, 3) = b2
            D(3, 1) = b2 : D(3, 2) = b2
            D(4, 4) = b3 : D(5, 5) = b3 : D(6, 6) = b3
        End If

        For i = 1 To 60
            For j = i To 60
                Ek(i, j) = 0
            Next j
        Next i

        j = 0
        For ii = 1 To 20
            i = NNelemC(ie, ii)
            XE(ii) = Xdata(i)
            YE(ii) = Ydata(i)
            ZE(ii) = Zdata(i)
            For id = 1 To 3
                j = j + 1
                If KindDPL > 0 Then
                    Select Case id
                        Case 1
                            XE(ii) = XE(ii) + zbuf(j)
                        Case 2
                            YE(ii) = YE(ii) + zbuf(j)
                        Case 3
                            ZE(ii) = ZE(ii) + zbuf(j)
                    End Select
                End If
            Next id
        Next ii

        Call CoeffMatrix2(ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算2

    End Sub

    Private Sub ElemMatrixBar(ByVal ie As Integer, ByVal istage As Integer)
        '要素ﾏﾄﾘｯｸｽの計算（部材）
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        Dim ib, id, ii, j, k, nb, ndimb, nvarb As Integer

        j = 0
        For ii = 1 To 2
            ib = NNelemC(ie, ii)
            If KindEC(ie) < 3 Then
                If KindEC(ie) = 1 Then
                    ndimb = 3
                    nvarb = 6
                Else
                    ndimb = 6
                    nvarb = 12
                End If
                k = NvarPSum(Kcomp(ib) - 1)
                For id = 1 To ndimb
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = Lcomp(k)
                    If istage > 0 Then
                        Efb(j) = Tf(Lcomp(k))
                    End If
                Next id
            Else
                nvarb = 12
                k = NvarPSum(Kcomp(ib) - 1)
                nb = NvarP(Kcomp(ib))
                For id = 1 To 6
                    j = j + 1
                    k = k + 1
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = Lcomp(k)
                    End If
                    If istage > 0 Then
                        If id > nb Then
                            Efb(j) = 0
                        Else
                            Efb(j) = Tf(Lcomp(k))
                        End If
                    End If
                Next id
            End If
        Next ii

        For ib = 1 To nvarb
            For j = 1 To nvarb
                Ek(ib, j) = 0
                Trans(ib, j) = 0
            Next j
        Next ib

        Call TransMatrix(ie)    '座標変換行列の設定
        If KindEC(ie) < 3 Then
            Call CoeffMatrixBar(istage, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            Call CoeffMatrixBar2(istage, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If


    End Sub

    Private Sub ElemMatrixBar2(ByVal ie As Integer)
        '要素ﾏﾄﾘｯｸｽの計算（部材）
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        Dim ib, id, ii, j, k, nb, ndimb, nvarb As Integer

        j = 0
        For ii = 1 To 2
            ib = NNelemC(ie, ii)
            If KindEC(ie) < 3 Then
                If KindEC(ie) = 1 Then
                    ndimb = 3
                    nvarb = 6
                Else
                    ndimb = 6
                    nvarb = 12
                End If
                k = NvarPSum(Kcomp(ib) - 1)
                For id = 1 To ndimb
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = Lcomp(k)
                Next id
            Else
                nvarb = 12
                k = NvarPSum(Kcomp(ib) - 1)
                nb = NvarP(Kcomp(ib))
                For id = 1 To 6
                    j = j + 1
                    k = k + 1
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = Lcomp(k)
                    End If
                Next id
            End If
        Next ii

        For ib = 1 To nvarb
            For j = 1 To nvarb
                Ek(ib, j) = 0
                Trans(ib, j) = 0
            Next j
        Next ib

        Call TransMatrix(ie)    '座標変換行列の設定
        If KindEC(ie) < 3 Then
            Call CoeffMatrixBar(0, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            Call CoeffMatrixBar2(0, ie)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If


    End Sub

    Private Sub EquaCalc(ByVal cbuf() As Double, ByRef xanswer As Double, _
        ByVal xleft As Double, ByVal xright As Double)
        '主応力の3次方程式の計算（Regular Falsi法）
        'cbuf()･･･係数
        'xanswer･･･方程式の解（最初は初期値）
        'xleft･･･変数区間の下限値
        'xright･･･変数区間の上限値
        Dim iter, itermax As Integer
        Dim b1, epsf, fanswer, fleft, fright As Double
        fanswer = EquaValue(cbuf, xanswer)
        epsf = Math.Abs(fanswer) * 0.000001
        itermax = 100            '繰返し計算の打切り回数
        iter = 0

        Do
            fleft = EquaValue(cbuf, xleft)       'X下限値に対する関数値
            fright = EquaValue(cbuf, xright)     'X上限値に対する関数値

            b1 = fright - fleft
            If b1 = 0 Then
                xanswer = xleft
                Exit Do
            End If
            xanswer = (xleft * fright - xright * fleft) / b1
            fanswer = EquaValue(cbuf, xanswer)

            If fanswer * fright > 0 Then
                xright = xanswer
            Else
                xleft = xanswer
            End If
            iter = iter + 1
        Loop Until Math.Abs(fanswer) < epsf Or iter = itermax

    End Sub

    Private Function EquaValue(ByVal cbuf() As Double, _
        ByVal xb As Double) As Double
        'Xに対する関数値
        'cbuf()･･･係数
        'xb･･･Xの値
        EquaValue = xb ^ 3 + cbuf(2) * xb * xb + cbuf(1) * xb + cbuf(0)

    End Function

    Private Sub FALoadSet()
        '座標位置荷重の設定
        Dim aa$
        Dim i, id, j, jb, k, kb, ke, kk As Integer
        Dim s, t, u, xb, yb, zb As Single

        Call AxisCheck(1, NelemC, Rlenmax, AxisMax, AxisMin, Xdata, Ydata, Zdata)
        'X、Y、Z軸の最小・最大値のﾁｪｯｸ
        EpsL = Rlenmax * 0.00001

        CInc = 3
        CRed = 0.2
        For i = 1 To NforceAC
            xb = XFA(i)
            yb = YFA(i)
            zb = ZFA(i)
            Call ElemFA(ke, s, t, u, xb, yb, zb) '該当要素の検出
            If ke = 0 Then
                aa$ = "座標位置荷重の座標が構造外にあります！"
                MsgBox(aa$, 0, "データエラー")
                Me.Close()
            End If
            For j = 1 To 20
                kk = NNelemC(ke, j)
                kb = Kcomp(kk)
                jb = NvarPSum(kb - 1)
                For id = 1 To 3
                    k = jb + id
                    If Lcomp(k) > 0 Then
                        Tf(Lcomp(k)) = Tf(Lcomp(k)) + Shape(j) * ForceAC(i, id)
                    End If
                Next id
            Next j
        Next i

    End Sub

    Private Sub FLoadSet()
        '節点荷重の設定
        Dim i, id, j, j2, kb, kk As Integer
        For i = 1 To NforceC
            kk = KPforceC(i)
            kb = Kcomp(kk)
            j2 = NvarP(kb)
            j = NvarPSum(kb - 1)
            For id = 1 To j2
                j = j + 1
                If Lcomp(j) > 0 Then
                    Tf(Lcomp(j)) = ForceC(i, id)
                End If
            Next id
        Next i

    End Sub

    Private Sub FMaxMin(ByRef ic As Integer, ByVal ie As Integer, _
    ByVal ii As Integer, ByVal jj As Integer, ByVal zbuf() As Single)
        '軸力等の最大・最小のﾁｪｯｸ
        'ic･･･初期設定の有無（0:なし、1:有り）
        'ie･･･要素番号
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'zbuf()･･･各応力
        Dim k As Integer
        Dim zb As Single

        If ic = 0 Then
            For k = 0 To 12
                Select Case k
                    Case 0
                        zb = zbuf(0)
                    Case Is > 6
                        zb = zbuf(k - 6)
                    Case Else
                        zb = EForce(jj + k)
                End Select
                If k < 7 Then
                    KEfmax(k) = 1
                    KEfmin(k) = 1
                    KPfmax(k) = ii
                    KPfmin(k) = ii
                    Zfmax(k) = zb
                    Zfmin(k) = zb
                ElseIf k < 11 Then
                    Select Case k
                        Case 7
                            KEfmax(7) = 1
                            KPfmax(7) = ii
                            Zfmax(7) = zb
                        Case 8
                            KEfmin(7) = 1
                            KPfmin(7) = ii
                            Zfmin(7) = zb
                        Case 9
                            KEfmax(8) = 1
                            KPfmax(8) = ii
                            Zfmax(8) = zb
                        Case 10
                            KEfmin(8) = 1
                            KPfmin(8) = ii
                            Zfmin(8) = zb
                    End Select
                Else
                    KEfmax(k - 2) = 1
                    KPfmax(k - 2) = ii
                    Zfmax(k - 2) = zb
                End If
            Next k
            ic = 1
        Else
            For k = 0 To 12
                Select Case k
                    Case 0
                        zb = zbuf(0)
                    Case Is > 6
                        zb = zbuf(k - 6)
                    Case Else
                        zb = EForce(jj + k)
                End Select
                If k < 7 Then
                    If zb < Zfmin(k) Then
                        KEfmin(k) = ie
                        KPfmin(k) = ii
                        Zfmin(k) = zb
                    ElseIf zb > Zfmax(k) Then
                        KEfmax(k) = ie
                        KPfmax(k) = ii
                        Zfmax(k) = zb
                    End If
                ElseIf k < 11 Then
                    Select Case k
                        Case 7
                            If zb > Zfmax(7) Then
                                KEfmax(7) = ie
                                KPfmax(7) = ii
                                Zfmax(7) = zb
                            End If
                        Case 8
                            If zb < Zfmin(7) Then
                                KEfmin(7) = ie
                                KPfmin(7) = ii
                                Zfmin(7) = zb
                            End If
                        Case 9
                            If zb > Zfmax(8) Then
                                KEfmax(8) = ie
                                KPfmax(8) = ii
                                Zfmax(8) = zb
                            End If
                        Case 10
                            If zb < Zfmin(8) Then
                                KEfmin(8) = ie
                                KPfmin(8) = ii
                                Zfmin(8) = zb
                            End If
                    End Select
                Else
                    If zb > Zfmax(k - 2) Then
                        KEfmax(k - 2) = ie
                        KPfmax(k - 2) = ii
                        Zfmax(k - 2) = zb
                    End If
                End If
            Next k
        End If

    End Sub

    Private Sub ForceCalc()
        '軸力等の計算
        Dim aa$
        Dim ib, ic, icount, ie, ii, istage, j, jj, k, kb, kflag, nb, k2 As Integer
        Dim area, b1, b2, b3, b4, bb, s As Double
        Dim zbuf(6) As Single
        Dim buf(6) As Double
        ReDim KEfmax(10), KEfmin(10), KPfmax(10), KPfmin(10)
        ReDim Zfmax(10), Zfmin(10)

        aa$ = "＜要素No.、節点No.、σf、軸力、ＦyB、ＦzB、ＭxB、ＭyB，ＭzB"
        aa$ = aa$ + "、     σbU、σbL、σAU、σAL、τA、τp＞"
        SwK.WriteLine("--------------------------------------------------")
        SwK.WriteLine("＊＊ 部材要素の応力・軸力等の出力 ＊＊")
        SwK.WriteLine(aa$)

        Application.DoEvents()
        icount = 0
        istage = 1
        ic = 0
        For ie = 1 To NelemC
            If KindEC(ie) > 0 Then
                If KindEC(ie) = 1 Then
                    nb = 6
                    k2 = 3
                Else
                    nb = 12
                    k2 = 6
                End If
                Call ElemMatrixBar(ie, istage)    '要素ﾏﾄﾘｯｸｽの計算
                For ib = 1 To nb
                    s = 0
                    For j = 1 To nb
                        s = s + Ekb(ib, j) * Efb(j)
                    Next j
                    EForce(ib) = s
                Next ib
                kb = NumMatC(ie)
                area = DataMatC(kb, 4)

                For j = 1 To 2
                    ii = NNelemC(ie, j)
                    GoTo Skip10
                    jj = 6 * (j - 1)
                    For k = 1 To 6
                        buf(k) = EForce(jj + k)
                    Next k
Skip10:
                    jj = k2 * (j - 1)
                    For k = 1 To k2
                        buf(k) = EForce(jj + k)
                    Next k

                    If j = 1 Then
                        buf(1) = -buf(1)
                    End If
                    EForce(jj + 1) = buf(1) + BarForce(ie, j)
                    EForce(jj + 2) = buf(2) + BarYShear(ie, j)
                    EForce(jj + 3) = buf(3) + BarZShear(ie, j)
                    zbuf(0) = EForce(jj + 1) / area
                    kflag = 0
                    If KindEC(ie) > 1 Then
                        kflag = 1
                    End If
                    If kflag = 0 Then
                        For k = 1 To 6
                            zbuf(k) = 0
                        Next k
                        zbuf(3) = zbuf(0)
                        zbuf(4) = zbuf(0)
                    Else
                        EForce(jj + 4) = buf(4)
                        EForce(jj + 5) = buf(5) + BarYMoment(ie, j)
                        EForce(jj + 6) = buf(6) + BarZMoment(ie, j)
                        b1 = -EForce(jj + 5) / DataMatC(kb, 8)
                        b2 = EForce(jj + 5) / DataMatC(kb, 9)
                        b3 = -EForce(jj + 6) / DataMatC(kb, 10)
                        b4 = EForce(jj + 6) / DataMatC(kb, 11)
                        zbuf(1) = b1 + b3
                        zbuf(2) = zbuf(1)
                        zbuf(3) = b1 + b4
                        zbuf(4) = b2 + b3
                        zbuf(5) = b2 + b4
                        For k = 3 To 5
                            If zbuf(k) > zbuf(1) Then
                                zbuf(1) = zbuf(k)
                            ElseIf zbuf(k) < zbuf(2) Then
                                zbuf(2) = zbuf(k)
                            End If
                        Next k
                        zbuf(3) = zbuf(1) + zbuf(0)
                        zbuf(4) = zbuf(2) + zbuf(0)
                        zbuf(6) = Math.Abs(EForce(jj + 4)) / DataMatC(kb, 14)
                    End If
                    b1 = Math.Abs(EForce(jj + 2))
                    b2 = Math.Abs(EForce(jj + 3))
                    b3 = Math.Sqrt(b1 * b1 + b2 * b2)
                    bb = b1 + b2
                    If bb = 0 Then
                        b4 = 0
                    Else
                        b4 = (b1 * DataMatC(kb, 12) + b2 * DataMatC(kb, 13)) / bb
                    End If
                    zbuf(5) = b4 * b3 / area
                    Call ForceOut(ie, ii, jj, zbuf) '軸力等の出力
                    Call FMaxMin(ic, ie, ii, jj, zbuf) '軸力等の最大・最小のﾁｪｯｸ
                Next j
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

    End Sub

    Private Sub ForceOut(ByVal ie As Integer, ByVal ii As Integer, _
    ByVal jj As Integer, ByVal zbuf() As Single)
        '軸力等の出力
        'ie･･･要素番号
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'zbuf()･･･各応力
        Dim aa$
        Dim j As Integer
        Dim z1 As Single

        aa$ = Str(ie) + ",  " + Str(ii) + ",  " + Str(zbuf(0))
        For j = 1 To 3
            z1 = EForce(jj + j)
            aa$ = aa$ + ",  " + Str(z1)
        Next j
        For j = 4 To 6
            z1 = EForce(jj + j)
            aa$ = aa$ + ",  " + Str(z1)
        Next j
        For j = 1 To 6
            If j = 1 Then
                aa$ = aa$ + ",     " + Str(zbuf(j))
            Else
                aa$ = aa$ + ",  " + Str(zbuf(j))
            End If
        Next j
        SwK.WriteLine(aa$)

    End Sub

    Private Sub GLoadSet()
        '自重の節点荷重への換算
        Dim i, ie, ig, ii, j, jg As Integer
        Dim k, kg, kgaus, kp, numg As Integer
        Dim b1, b2, dj, dv, gforce, ratio As Double
        Dim s, sumdiag, t, totalmass, u As Double
        Dim buf(20) As Double

        For ie = 1 To NelemC
            If KindEC(ie) = 0 Then
                kp = NumMatC(ie)
                gforce = DataMatC(kp, 3)
                For ii = 1 To 20
                    buf(ii) = 0
                    i = NNelemC(ie, ii)
                    XE(ii) = Xdata(i)
                    YE(ii) = Ydata(i)
                    ZE(ii) = Zdata(i)
                    If KindDPL > 0 Then
                        k = NvarPSum(Kcomp(i) - 1)
                        XE(ii) = XE(ii) + Tfx(Lcomp(k + 1))
                        YE(ii) = YE(ii) + Tfx(Lcomp(k + 2))
                        ZE(ii) = ZE(ii) + Tfx(Lcomp(k + 3))
                    End If
                Next ii

                totalmass = 0   '要素重量合計
                sumdiag = 0     '節点の積分重量合計
                numg = 0
                For ig = 1 To Ngaus
                    s = PosGaus(ig)
                    For jg = 1 To Ngaus
                        t = PosGaus(jg)
                        For kg = 1 To Ngaus
                            numg = numg + 1
                            u = PosGaus(kg)
                            Call ShapeFunc(1, s, t, u)         '形状関数の計算
                            Call JacobElem(ie, kgaus, numg, dj)
                            '要素のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算
                            dv = dj * WeightG(ig) * WeightG(jg) * WeightG(kg)
                            b1 = gforce * dv
                            If KindGravC > 0 Then
                                totalmass = totalmass + b1
                                For i = 1 To 20
                                    b2 = b1 * Shape(i) * Shape(i)
                                    sumdiag = sumdiag + b2
                                    buf(i) = buf(i) + b2
                                Next i
                            End If
                        Next kg
                    Next jg
                Next ig
                If KindGravC > 0 And sumdiag <> 0 Then
                    '要素重量合計の補正・蓄積
                    ratio = totalmass / sumdiag
                    For ii = 1 To 20
                        b1 = buf(ii) * ratio
                        i = NNelemC(ie, ii)
                        j = NvarPSum(Kcomp(i) - 1)
                        For k = 1 To 3
                            j = j + 1
                            b2 = b1 * GravMultiC(k)
                            If Lcomp(j) > 0 Then
                                Tf(Lcomp(j)) = Tf(Lcomp(j)) + b2
                            End If
                        Next k
                    Next ii
                End If
            Else
                If KindEC(ie) < 3 Then
                    Call GLoadSet1(ie)  '自重荷重の加算（トラス、ラーメン）
                Else
                    Call GLoadSet2(ie)  '自重荷重の加算（混合部材）
                End If
            End If

        Next ie

    End Sub

    Private Sub GLoadSet1(ByVal ie As Integer)
        '自重荷重の加算（トラス、ラーメン）
        '軸力等は初期内力として処理
        'ie･･･要素No.
        Dim ii, j, k, kb, kk, kp, kx As Integer
        Dim area, forceb, pny, pnz, ptload, rmomentb As Double
        Dim ud, weightk, weights As Double
        Dim kbuf(2) As Integer
        Dim buf(3) As Double

        kp = NumMatC(ie)
        ud = DataMatC(kp, 3)
        area = DataMatC(kp, 4)
        If ud > 0 Then
            For ii = 1 To 2
                kx = NNelemC(ie, ii)
                kbuf(ii) = NvarPSum(Kcomp(kx) - 1)
            Next ii
            weights = ud * area * RlenBar(ie) '要素の重量
            For kk = 1 To 3
                If GravMultiC(kk) <> 0 Then
                    weightk = weights * GravMultiC(kk)
                    pny = weightk * CosYBar(ie, kk)
                    pnz = weightk * CosZBar(ie, kk)
                    ptload = weightk * CosXBar(ie, kk)

                    If pny <> 0 Then
                        '垂直荷重Ｐnyによる換算荷重の計算
                        forceb = 0.5 * pny
                        For j = 1 To 3
                            buf(j) = forceb * CosYBar(ie, j)
                        Next j
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + buf(j)
                                End If
                            Next j
                        Next ii
                        BarYShear(ie, 1) = BarYShear(ie, 1) - forceb
                        BarYShear(ie, 2) = BarYShear(ie, 2) - forceb
                        If KindEC(ie) = 2 Then
                            rmomentb = forceb * RlenBar(ie) / 6
                            For j = 1 To 3
                                buf(j) = rmomentb * CosZBar(ie, j)
                            Next j
                            For ii = 1 To 2
                                k = kbuf(ii)
                                For j = 1 To 3
                                    kb = Lcomp(k + j + 3)
                                    If kb > 0 Then
                                        If ii = 1 Then
                                            Tf(kb) = Tf(kb) + buf(j)
                                        Else
                                            Tf(kb) = Tf(kb) - buf(j)
                                        End If
                                    End If
                                Next j
                            Next ii
                            BarZMoment(ie, 1) = BarZMoment(ie, 1) - rmomentb
                            BarZMoment(ie, 2) = BarZMoment(ie, 2) + rmomentb
                        End If
                    End If

                    If pnz <> 0 Then
                        '垂直荷重Ｐnzによる換算荷重の計算
                        forceb = 0.5 * pnz
                        For j = 1 To 3
                            buf(j) = forceb * CosZBar(ie, j)
                        Next j
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + buf(j)
                                End If
                            Next j
                        Next ii
                        BarZShear(ie, 1) = BarZShear(ie, 1) - forceb
                        BarZShear(ie, 2) = BarZShear(ie, 2) - forceb
                        If KindEC(ie) = 2 Then
                            rmomentb = -forceb * RlenBar(ie) / 6
                            For j = 1 To 3
                                buf(j) = rmomentb * CosYBar(ie, j)
                            Next j
                            For ii = 1 To 2
                                k = kbuf(ii)
                                For j = 1 To 3
                                    kb = Lcomp(k + j + 3)
                                    If kb > 0 Then
                                        If ii = 1 Then
                                            Tf(kb) = Tf(kb) + buf(j)
                                        Else
                                            Tf(kb) = Tf(kb) - buf(j)
                                        End If
                                    End If
                                Next j
                            Next ii
                            BarYMoment(ie, 1) = BarYMoment(ie, 1) - rmomentb
                            BarYMoment(ie, 2) = BarYMoment(ie, 2) + rmomentb
                        End If
                    End If

                    If ptload <> 0 Then
                        '接線荷重Ｐtによる換算荷重の計算
                        forceb = 0.5 * ptload
                        For j = 1 To 3
                            buf(j) = forceb * CosXBar(ie, j)
                        Next j
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + buf(j)
                                End If
                            Next j
                        Next ii
                        BarForce(ie, 1) = BarForce(ie, 1) + forceb
                        BarForce(ie, 2) = BarForce(ie, 2) - forceb
                    End If
                End If
            Next kk
        End If

    End Sub

    Private Sub GLoadSet2(ByVal ie As Integer)
        '自重荷重の加算（部材混合）
        '軸力等は初期内力として処理
        'ie･･･要素No.
        Dim ii, j, k, kb, kk, kp, kx As Integer
        Dim cb As Single
        Dim area, b1, forceb, pny, pnz, ptload As Double
        Dim rmoment1, rmoment2, rmomentb As Double
        Dim ud, weightk, weights As Double
        Dim kbuf(2) As Integer
        Dim buf(3), fbuf(2) As Double

        cb = 1.0 - CrateA
        kp = NumMatC(ie)
        ud = DataMatC(kp, 3)
        area = DataMatC(kp, 4)
        If ud > 0 Then
            For ii = 1 To 2
                kx = NNelemC(ie, ii)
                kbuf(ii) = NvarPSum(Kcomp(kx) - 1)
            Next ii
            weights = ud * area * RlenBar(ie) '要素の重量
            For kk = 1 To 3
                If GravMultiC(kk) <> 0 Then
                    weightk = weights * GravMultiC(kk)
                    pny = weightk * CosYBar(ie, kk)
                    pnz = weightk * CosZBar(ie, kk)
                    ptload = weightk * CosXBar(ie, kk)
                    If pny <> 0 Then
                        '垂直荷重Ｐnyによる換算荷重の計算
                        Select Case KindEC(ie)
                            Case 3
                                fbuf(1) = 3 * pny / 8
                                fbuf(2) = 5 * pny / 8
                                rmomentb = pny * RlenBar(ie) / 8
                            Case 4
                                fbuf(1) = 5 * pny / 8
                                fbuf(2) = 3 * pny / 8
                                rmomentb = pny * RlenBar(ie) / 8
                        End Select
                        b1 = CrateA * 0.5 * pny
                        fbuf(1) = cb * fbuf(1) + b1
                        fbuf(2) = cb * fbuf(2) + b1
                        Select Case KindEC(ie)
                            Case 3
                                rmoment1 = CrateA * pny * RlenBar(ie) / 12
                                rmoment2 = cb * rmomentb + rmoment1
                            Case 4
                                rmoment2 = CrateA * pny * RlenBar(ie) / 12
                                rmoment1 = cb * rmomentb + rmoment2
                        End Select
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + fbuf(ii) * CosYBar(ie, j)
                                End If
                            Next j
                            For j = 1 To 3
                                kb = Lcomp(k + j + 3)
                                If kb > 0 Then
                                    If ii = 1 Then
                                        Tf(kb) = Tf(kb) + rmoment1 * CosZBar(ie, j)
                                    Else
                                        Tf(kb) = Tf(kb) - rmoment2 * CosZBar(ie, j)
                                    End If
                                End If
                            Next j
                        Next ii
                        BarYShear(ie, 1) = BarYShear(ie, 1) - fbuf(1)
                        BarYShear(ie, 2) = BarYShear(ie, 2) - fbuf(2)
                        BarZMoment(ie, 1) = BarZMoment(ie, 1) - rmoment1
                        BarZMoment(ie, 2) = BarZMoment(ie, 2) + rmoment2
                    End If

                    If pnz <> 0 Then
                        '垂直荷重Ｐnzによる換算荷重の計算
                        Select Case KindEC(ie)
                            Case 3
                                fbuf(1) = 3 * pnz / 8
                                fbuf(2) = 5 * pnz / 8
                                rmomentb = -pnz * RlenBar(ie) / 8
                            Case 4
                                fbuf(1) = 5 * pnz / 8
                                fbuf(2) = 3 * pnz / 8
                                rmomentb = -pnz * RlenBar(ie) / 8
                        End Select
                        b1 = CrateA * 0.5 * pnz
                        fbuf(1) = cb * fbuf(1) + b1
                        fbuf(2) = cb * fbuf(2) + b1
                        Select Case KindEC(ie)
                            Case 3
                                rmoment1 = -CrateA * pnz * RlenBar(ie) / 12
                                rmoment2 = cb * rmomentb + rmoment1
                            Case 4
                                rmoment2 = -CrateA * pnz * RlenBar(ie) / 12
                                rmoment1 = cb * rmomentb + rmoment2
                        End Select
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + fbuf(ii) * CosZBar(ie, j)
                                End If
                            Next j
                            For j = 1 To 3
                                kb = Lcomp(k + j + 3)
                                If kb > 0 Then
                                    If ii = 1 Then
                                        Tf(kb) = Tf(kb) + rmoment1 * CosYBar(ie, j)
                                    Else
                                        Tf(kb) = Tf(kb) - rmoment2 * CosYBar(ie, j)
                                    End If
                                End If
                            Next j
                        Next ii
                        BarZShear(ie, 1) = BarZShear(ie, 1) - fbuf(1)
                        BarZShear(ie, 2) = BarZShear(ie, 2) - fbuf(2)
                        BarYMoment(ie, 1) = BarYMoment(ie, 1) - rmoment1
                        BarYMoment(ie, 2) = BarYMoment(ie, 2) + rmoment2
                    End If

                    If ptload <> 0 Then
                        '接線荷重Ｐtによる換算荷重の計算
                        forceb = 0.5 * ptload
                        For j = 1 To 3
                            buf(j) = forceb * CosXBar(ie, j)
                        Next j
                        For ii = 1 To 2
                            k = kbuf(ii)
                            For j = 1 To 3
                                kb = Lcomp(k + j)
                                If kb > 0 Then
                                    Tf(kb) = Tf(kb) + buf(j)
                                End If
                            Next j
                        Next ii
                        BarForce(ie, 1) = BarForce(ie, 1) + forceb
                        BarForce(ie, 2) = BarForce(ie, 2) - forceb
                    End If
                End If
            Next kk
        End If

    End Sub

    Private Sub HLoadSet()
        '分布荷重の節点荷重への換算
        Dim i, ib, id, ie, ii, j, jb, jj As Integer
        Dim k1, k2, kb, kgp1, kgp2, kind, kk, numg As Integer
        Dim b1, da, dj, xb, yb, zb As Double
        Dim kbuf(8) As Integer
        Dim planevec(3), xbuf(3), ybuf(3), zbuf(3) As Single
        Dim gpos(3) As Double

        For ii = 1 To NsurfC
            ie = KPsurfC(ii, 1)
            kb = KPsurfC(ii, 2)
            If KindEC(ie) = 0 Then
                Call SurfaceCond(kb, kind, kbuf, gpos)  '境界条件用の面設定
                For j = 1 To 20
                    ib = NNelemC(ie, j)
                    XE(j) = Xdata(ib)
                    YE(j) = Ydata(ib)
                    ZE(j) = Zdata(ib)
                    If KindDPL > 0 Then
                        k1 = NvarPSum(Kcomp(ib) - 1)
                        XE(j) = XE(j) + Tfx(Lcomp(k1 + 1))
                        YE(j) = YE(j) + Tfx(Lcomp(k1 + 2))
                        ZE(j) = ZE(j) + Tfx(Lcomp(k1 + 3))
                    End If
                Next j

                xb = 0 : yb = 0 : zb = 0
                For j = 2 To 8 Step 2
                    kb = kbuf(j)
                    ib = NNelemC(ie, kb)
                    xb = xb + Xdata(ib)
                    yb = yb + Ydata(ib)
                    zb = zb + Zdata(ib)
                    Select Case j
                        Case 2
                            xbuf(2) = Xdata(ib)
                            ybuf(2) = Ydata(ib)
                            zbuf(2) = Zdata(ib)
                        Case 4
                            xbuf(3) = Xdata(ib)
                            ybuf(3) = Ydata(ib)
                            zbuf(3) = Zdata(ib)
                    End Select
                    If KindDPL > 0 Then
                        k1 = NvarPSum(Kcomp(ib) - 1)
                        xb = xb + Tfx(Lcomp(k1 + 1))
                        yb = yb + Tfx(Lcomp(k1 + 2))
                        zb = zb + Tfx(Lcomp(k1 + 3))
                        If j = 2 Or j = 4 Then
                            If j = 2 Then
                                k2 = 2
                            Else
                                k2 = 3
                            End If
                            xbuf(k2) = xbuf(k2) + Tfx(Lcomp(k1 + 1))
                            ybuf(k2) = ybuf(k2) + Tfx(Lcomp(k1 + 2))
                            zbuf(k2) = zbuf(k2) + Tfx(Lcomp(k1 + 3))
                        End If
                    End If
                Next j
                xbuf(1) = xb / 4
                ybuf(1) = yb / 4
                zbuf(1) = zb / 4

                Call SurfaceVector(planevec, xbuf, ybuf, zbuf)
                '面の法線ﾍﾞｸﾄﾙの計算

                Select Case kind
                    Case 1
                        kgp1 = 1
                        kgp2 = 2
                        jj = 3
                    Case 2
                        kgp1 = 1
                        kgp2 = 3
                        jj = 2
                    Case 3
                        kgp1 = 2
                        kgp2 = 3
                        jj = 1
                End Select
                numg = 0
                For k1 = 1 To Ngaus
                    gpos(kgp1) = PosGaus(k1)
                    For k2 = 1 To Ngaus
                        gpos(kgp2) = PosGaus(k2)
                        numg = numg + 1
                        Call ShapeFunc(1, gpos(1), gpos(2), gpos(3))
                        '形状関数の計算

                        Call JacobElem2(ie, numg, dj, kbuf)
                        '要素表面のﾔｺﾋﾞｱﾝ ﾏﾄﾘｯｸｽの計算

                        da = 0
                        For i = 1 To 3
                            b1 = RinvJ(i, jj)
                            da = da + b1 * b1
                        Next i
                        da = Math.Sqrt(da) * WeightG(k1) * WeightG(k2)
                        For i = 1 To 8
                            kk = kbuf(i)
                            j = Kcomp(NNelemC(ie, kk))
                            b1 = PsurfC(ii, 1) * Shape(kk) * da
                            jb = NvarPSum(j - 1)
                            For id = 1 To 3
                                jb = jb + 1
                                If Lcomp(jb) > 0 Then
                                    Tf(Lcomp(jb)) = Tf(Lcomp(jb)) - b1 * planevec(id)
                                End If
                            Next id
                        Next i
                    Next k2
                Next k1

            Else
                If KindEC(ie) < 3 Then
                    Call HLoadSet1(ii, ie)  '部材の分布荷重の設定（トラス、ラーメン）
                Else
                    Call HLoadSet2(ii, ie)  '部材の分布荷重の設定（混合部材）
                End If
            End If

        Next ii

    End Sub

    Private Sub HLoadSet1(ByVal ib As Integer, ByVal ie As Integer)
        '部材の分布荷重の設定（トラス、ラーメン）
        '軸力等は初期内力として処理
        'ib･･･分布荷重No.
        'ie･･･要素No.
        Dim ii, kb, kk As Integer
        Dim forceb, rmomentb As Double
        Dim kbuf(2) As Integer
        Dim buf(3) As Double

        For ii = 1 To 2
            kb = NNelemC(ie, ii)
            kbuf(ii) = NvarPSum(Kcomp(kb) - 1)
        Next ii

        '垂直分布荷重Ｐnyによる換算荷重の計算
        forceb = 0.5 * PsurfC(ib, 1) * RlenBar(ie)
        For kk = 1 To 3
            buf(kk) = forceb * CosYBar(ie, kk)
        Next kk
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + buf(kk)
                End If
            Next kk
        Next ii
        BarYShear(ie, 1) = -forceb
        BarYShear(ie, 2) = -forceb
        If KindEC(ie) = 2 Then
            rmomentb = forceb * RlenBar(ie) / 6
            For kk = 1 To 3
                buf(kk) = rmomentb * CosZBar(ie, kk)
            Next kk
            For ii = 1 To 2
                For kk = 1 To 3
                    kb = Lcomp(kbuf(ii) + 3 + kk)
                    If kb > 0 Then
                        If ii=1 Then
                            Tf(kb) = Tf(kb) + buf(kk)
                        Else
                            Tf(kb) = Tf(kb) - buf(kk)
                        End If
                    End If
                Next kk
            Next ii
            BarZMoment(ie, 1) = -rmomentb
            BarZMoment(ie, 2) = rmomentb
        End If

        '垂直分布荷重Ｐnzによる換算荷重の計算
        forceb = 0.5 * PsurfC(ib, 2) * RlenBar(ie)
        For kk = 1 To 3
            buf(kk) = forceb * CosZBar(ie, kk)
        Next kk
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + buf(kk)
                End If
            Next
        Next ii
        BarZShear(ie, 1) = -forceb
        BarZShear(ie, 2) = -forceb
        If KindEC(ie) = 2 Then
            rmomentb = -forceb * RlenBar(ie) / 6
            For kk = 1 To 3
                buf(kk) = rmomentb * CosYBar(ie, kk)
            Next kk
            For ii = 1 To 2
                For kk = 1 To 3
                    kb = Lcomp(kbuf(ii) + 3 + kk)
                    If kb > 0 Then
                        If ii = 1 Then
                            Tf(kb) = Tf(kb) + buf(kk)
                        Else
                            Tf(kb) = Tf(kb) - buf(kk)
                        End If
                    End If
                Next kk
            Next ii
            BarYMoment(ie, 1) = -rmomentb
            BarYMoment(ie, 2) = rmomentb
        End If

        '接線分布荷重Ｐtによる換算荷重の計算
        forceb = 0.5 * PsurfC(ib, 3) * RlenBar(ie)
        For kk = 1 To 3
            buf(kk) = forceb * CosXBar(ie, kk)
        Next kk
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + buf(kk)
                End If
            Next kk
        Next ii
        BarForce(ie, 1) = forceb
        BarForce(ie, 2) = -forceb

    End Sub

    Private Sub HLoadSet2(ByVal ib As Integer, ByVal ie As Integer)
        '分布荷重の設定（混合部材）
        '軸力等は初期内力として処理
        'ib･･･分布荷重No.
        'ie･･･要素No.
        Dim ii, kb, kk As Integer
        Dim cb As Single
        Dim b1, forceb, rmoment1, rmoment2, rmomentb As Double
        Dim kbuf(2) As Integer
        Dim buf(3), fbuf(3) As Single
        Dim fnorm(2) As Double

        cb = 1.0 - CrateA
        fbuf(1) = PsurfC(ib, 1)
        fbuf(2) = PsurfC(ib, 2)
        fbuf(3) = PsurfC(ib, 3)
        For ii = 1 To 2
            kb = NNelemC(ie, ii)
            kbuf(ii) = NvarPSum(Kcomp(kb) - 1)
        Next ii

        '垂直分布荷重Ｐnyによる換算荷重の計算
        Select Case KindEC(ie)
            Case 3
                fnorm(1) = 3 * fbuf(1) * RlenBar(ie) / 8
                fnorm(2) = 5 * fbuf(1) * RlenBar(ie) / 8
                rmomentb = fbuf(1) * RlenBar(ie) * RlenBar(ie) / 8
            Case 4
                fnorm(1) = 5 * fbuf(1) * RlenBar(ie) / 8
                fnorm(2) = 3 * fbuf(1) * RlenBar(ie) / 8
                rmomentb = fbuf(1) * RlenBar(ie) * RlenBar(ie) / 8
        End Select
        b1 = CrateA * 0.5 * fbuf(1) * RlenBar(ie)
        fnorm(1) = cb * fnorm(1) + b1
        fnorm(2) = cb * fnorm(2) + b1
        If KindEC(ie) = 3 Then
            rmoment1 = b1 * RlenBar(ie) / 6
            rmoment2 = cb * rmomentb + rmoment1
        Else
            rmoment2 = b1 * RlenBar(ie) / 6
            rmoment1 = cb * rmomentb + rmoment2
        End If
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + fnorm(ii) * CosYBar(ie, kk)
                End If
            Next kk
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk + 3)
                If kb > 0 Then
                    If ii = 1 Then
                        Tf(kb) = Tf(kb) + rmoment1 * CosZBar(ie, kk)
                    Else
                        Tf(kb) = Tf(kb) - rmoment2 * CosZBar(ie, kk)
                    End If
                End If
            Next kk
        Next ii
        BarYShear(ie, 1) = -fnorm(1)
        BarYShear(ie, 2) = -fnorm(2)
        BarZMoment(ie, 1) = -rmoment1
        BarZMoment(ie, 2) = rmoment2


        '垂直分布荷重Ｐnzによる換算荷重の計算
        Select Case KindEC(ie)
            Case 3
                fnorm(1) = 3 * fbuf(2) * RlenBar(ie) / 8
                fnorm(2) = 5 * fbuf(2) * RlenBar(ie) / 8
                rmomentb = -fbuf(2) * RlenBar(ie) * RlenBar(ie) / 8
            Case 4
                fnorm(1) = 5 * fbuf(2) * RlenBar(ie) / 8
                fnorm(2) = 3 * fbuf(2) * RlenBar(ie) / 8
                rmomentb = -fbuf(2) * RlenBar(ie) * RlenBar(ie) / 8
        End Select
        b1 = CrateA * 0.5 * fbuf(2) * RlenBar(ie)
        fnorm(1) = cb * fnorm(1) + b1
        fnorm(2) = cb * fnorm(2) + b1
        If KindEC(ie) = 3 Then
            rmoment1 = -b1 * RlenBar(ie) / 6
            rmoment2 = cb * rmomentb + rmoment1
        Else
            rmoment2 = -b1 * RlenBar(ie) / 6
            rmoment1 = cb * rmomentb + rmoment2
        End If
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + fnorm(ii) * CosZBar(ie, kk)
                End If
            Next kk
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk + 3)
                If kb > 0 Then
                    If ii = 1 Then
                        Tf(kb) = Tf(kb) + rmoment1 * CosYBar(ie, kk)
                    Else
                        Tf(kb) = Tf(kb) - rmoment2 * CosYBar(ie, kk)
                    End If
                End If
            Next kk
        Next ii
        BarZShear(ie, 1) = -fnorm(1)
        BarZShear(ie, 2) = -fnorm(2)
        BarYMoment(ie, 1) = -rmoment1
        BarYMoment(ie, 2) = rmoment2

        '接線分布荷重Ｐtによる換算荷重の計算
        forceb = 0.5 * fbuf(3) * RlenBar(ie)
        For kk = 1 To 3
            buf(kk) = forceb * CosXBar(ie, kk)
        Next kk
        For ii = 1 To 2
            For kk = 1 To 3
                kb = Lcomp(kbuf(ii) + kk)
                If kb > 0 Then
                    Tf(kb) = Tf(kb) + buf(kk)
                End If
            Next kk
        Next ii
        BarForce(ie, 1) = forceb
        BarForce(ie, 2) = -forceb

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim aa$
        Dim i, ic, id, ie, j, j2, jb, k, kb, nb, nex As Integer

        'Nvar = 60
        Nall = NvarPSum(NpointC)

        ReDim NPrefer(60), Ek(60, 60), B(6, 60)
        ReDim D(6, 6), Db(6, 60)
        ReDim Nw(NpointC), Eu(60)
        ReDim Sgaus(27, 6), Spoint(20, 6)
        ReDim Tp(NpointC, 6)

        '部材用
        ReDim CosXBar(NelemC, 3), CosZBar(NelemC, 3)
        ReDim RlenBar(NelemC)
        ReDim Ekb(12, 12), Trans(12, 12)
        ReDim EForce(12), Efb(12)
        ReDim BarForce(NelemC, 2), BarYShear(NelemC, 2), BarZShear(NelemC, 2)
        ReDim BarYMoment(NelemC, 2), BarZMoment(NelemC, 2)

        '拘束ﾃﾞｰﾀの処理
        nb = NboundPC
        If NboundSC > 0 Then
            nb = nb + 8 * NboundSC
        End If
        If nb > 0 Then
            Dim nrp(nb), jfix(nb, 6) As Integer
            Dim vfix(nb, 6) As Single
            k = 0
            If NboundPC > 0 Then
                For i = 1 To NboundPC
                    k = k + 1
                    nrp(k) = NrestPC(i)
                    For id = 1 To 6
                        jfix(k, id) = JdirectPC(i, id)
                        vfix(k, id) = VdirectPC(i, id)
                    Next id
                Next i
            End If
            If NboundSC > 0 Then
                Dim kbuf(8) As Integer
                For i = 1 To NboundSC
                    ie = KBsurfC(i, 1)
                    kb = KBsurfC(i, 2)
                    Call SurfaceSet(ie, kb, kbuf)   '面の設定
                    For j = 1 To 8
                        k = k + 1
                        nrp(k) = kbuf(j)
                        For id = 1 To 3
                            jfix(k, id) = JdirectSC(i, id)
                            vfix(k, id) = VdirectSC(i, id)
                        Next id
                    Next j
                Next i
            End If
            '節点重複の削除･･･最大採用
            For i = 1 To nb - 1
                For j = i + 1 To nb
                    If nrp(i) = nrp(j) Then
                        For id = 1 To 6
                            If jfix(j, id) > 0 Then
                                ic = 0
                                If jfix(i, id) = 0 Then
                                    ic = 1
                                ElseIf vfix(j, id) > vfix(i, id) Then
                                    ic = 1
                                End If
                                If ic > 0 Then
                                    jfix(i, id) = 1
                                    vfix(i, id) = vfix(j, id)
                                End If
                            End If
                        Next id
                        nrp(j) = 0
                    End If
                Next j
            Next i
            '拘束条件を新規保存（節点番号順）
            Nbound = 0
            For i = 1 To nb
                If nrp(i) > 0 Then
                    Nbound = Nbound + 1
                End If
            Next i
            ReDim Nrest(Nbound)
            ReDim Jdirect(Nbound, 6), Vdirect(Nbound, 6)
            For i = 1 To nbound
                ic = 0
                For j = 1 To nb
                    If nrp(j) > 0 Then
                        If ic = 0 Then
                            k = j
                            ic = 1
                        ElseIf nrp(j) < nrp(k) Then
                            k = j
                        End If
                    End If
                Next j
                Nrest(i) = nrp(k)
                For id = 1 To 6
                    Jdirect(i, id) = jfix(k, id)
                    Vdirect(i, id) = vfix(k, id)
                Next id
                nrp(k) = 0
            Next i

            '変数固定の整理
            Dim nrc(nbound) As Integer
            NBvar = 0
            For i = 1 To nbound
                nrc(i) = 1
                kb = Kcomp(nrest(i))
                j2 = NvarP(kb)
                For j = 1 To j2
                    If jdirect(i, j) <> 0 Then
                        NBvar = NBvar + 1
                    End If
                Next j
            Next i
            ReDim KBfix(NBvar), VBfix(NBvar)
            jb = 0
            For i = 1 To nbound
                ic = 0
                For j = 1 To nbound
                    If nrc(j) > 0 Then
                        If ic = 0 Then
                            k = j
                            kb = Kcomp(nrest(j))
                            ic = 1
                        ElseIf Kcomp(nrest(j)) < kb Then
                            k = j
                            kb = Kcomp(nrest(j))
                        End If
                    End If
                Next j

                j2 = NvarP(kb)          '節点の変数の数(3か6)
                kb = NvarPSum(kb - 1)   '前節点までの累積変数
                For j = 1 To j2
                    If jdirect(k, j) <> 0 Then
                        jb = jb + 1
                        KBfix(jb) = kb + j
                        VBfix(jb) = vdirect(k, j)
                    End If
                Next j
                nrc(k) = 0
            Next i

        Else
            aa$ = "拘束条件が設定されていません！"
            MsgBox(aa$, 0, "データエラー")
            End

        End If

        '縮小ﾏﾄﾘｯｸｽの設定
        ReDim Lcomp(Nall)
        For i = 1 To Nall       '全変数のﾏﾄﾘｯｸｽ組み入れを仮設定
            Lcomp(i) = 1
        Next i

        nex = 0
        For i = 1 To NBvar  '0固定の変位変数の除去
            If VBfix(i) = 0 Then
                nex = nex + 1
                Lcomp(KBfix(i)) = 0
            End If
        Next i
        Neff = Nall - nex
        ReDim Tf(Neff)
        If KindDPL > 0 Then
            ReDim Tfx(Neff)
        End If

        j = 0
        For i = 1 To Nall       '全変数の縮小ﾏﾄﾘｯｸｽへの対応付け
            If Lcomp(i) > 0 Then
                j = j + 1
                Lcomp(i) = j
            End If
        Next i

        PosGaus(3) = 0.77459667 : PosGaus(1) = -PosGaus(3) : PosGaus(2) = 0
        WeightG(1) = 0.55555556 : WeightG(3) = WeightG(1) : WeightG(2) = 0.88888889

    End Sub

    Private Sub InitialSet2(ByVal mb As Integer)
        '初期設定2
        Dim aa$
        Dim i, i1, ib, ic, id, ie, ii, ip, j, j2, k, k1, k2, kk, nmax, num, numall As Integer
        Dim b1, freemem, reqmem As Single
        Dim nbuf(NpointC) As Integer
        ReDim Idiag(Neff)

        '関連節点数の計算
        numall = 0
        For i = 1 To NpointC
            ic = 0
            j2 = NvarP(i)
            k = NvarPSum(i - 1)
            For id = 1 To j2
                If Lcomp(k + id) > 0 Then
                    ic = 1
                    Exit For
                End If
            Next id
            If ic > 0 Then
                For j = 1 To i
                    nbuf(j) = 0
                Next j
                ip = KRcomp(i)
                For ie = 1 To NelemC
                    If KindEC(ie) = 0 Then
                        nmax = 20
                    Else
                        nmax = 2
                    End If
                    ic = 0
                    For ii = 1 To nmax
                        If NNelemC(ie, ii) = ip Then
                            ic = 1
                            Exit For
                        End If
                    Next ii
                    If ic > 0 Then
                        For ii = 1 To nmax
                            ib = Kcomp(NNelemC(ie, ii))
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        Next ii
                    End If
                Next ie
                If NspringC > 0 Then
                    For j = 1 To NspringC
                        k1 = KPspringC(j, 1)
                        k2 = KPspringC(j, 2)
                        If k1 = ip Then
                            If k2 > 0 Then
                                ib = Kcomp(k2)
                                If ib <= i Then
                                    nbuf(ib) = 1
                                End If
                            End If
                        ElseIf k2 = ip Then
                            ib = Kcomp(k1)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    Next j
                End If
                i1 = 0
                For j = 1 To i
                    If nbuf(j) > 0 Then
                        i1 = j
                        Exit For
                    End If
                Next j
                k1 = 0
                For j = i1 To i
                    j2 = NvarP(j)
                    k = NvarPSum(j - 1)
                    For id = 1 To j2
                        If Lcomp(k + id) > 0 Then
                            k1 = Lcomp(k + id)
                            Exit For
                        End If
                    Next id
                    If k1 > 0 Then
                        Exit For
                    End If
                Next j
                j2 = NvarP(i)
                k = NvarPSum(i - 1)
                For id = 1 To j2
                    kk = Lcomp(k + id)
                    If kk > 0 Then
                        num = kk - k1 + 1
                        numall = numall + num
                        Idiag(kk) = numall
                    End If
                Next id
            End If
        Next i
        NumEff = numall

        freemem = 1000 * FreeMemoryGet()
        reqmem = 8.0 * NumEff * 1.05
        If reqmem > freemem Then
            b1 = reqmem / 100000000.0
            reqmem = (Int(b1) + 1) / 10
            aa$ = "変数の数が大き過ぎるため、配列変数のメモリーが足りません！"
            aa$ = aa$ + Chr(13) + Chr(10) + "スカイライン法で必要な空きメモリー容量は約"
            aa$ = aa$ + Str(reqmem) + "ＧＢです。"
            MsgBox(aa$, 0, "メモリー不足")
            End
        End If
        ReDim Tk(NumEff)

    End Sub

    Private Sub LoadSet()
        '荷重の設定
        If NforceC > 0 Then
            Call FLoadSet() '節点荷重の設定
        End If

        If NforceAC > 0 Then
            Call FALoadSet() '座標位置荷重の設定
        End If

        If NsurfC > 0 Then
            Call HLoadSet() '分布荷重の節点荷重への換算
        End If

        If KindGravC > 0 Then
            Call GLoadSet() '自重の節点荷重への換算
        End If

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力1
        'UTF-8･･･BOMなし
        Dim aa$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        SwK.WriteLine("＜＜複合３次元構造解析の計算結果＞＞")
        SwK.WriteLine(Title$)

        aa$ = "［入力データファイル］" + "," + Fm$
        SwK.WriteLine(aa$)
        SwK.WriteLine(DotLine$)

    End Sub

    Private Sub ResFile2(ByVal mb As Integer)
        '結果ﾌｧｲﾙへの出力2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$

        aa$ = "計算マトリックスの変数個数、ハーフバンド幅、保存インデックス数"
        SwK.WriteLine("＊＊＊ 計算結果（スカイライン法） ＊＊＊")
        SwK.WriteLine(aa$)
        aa$ = "   " + Str(Neff) + ",   " + Str(mb) + ",   " + Str(NumEff)
        SwK.WriteLine(aa$)
        SwK.WriteLine(DotLine$)

    End Sub

    Private Sub ResFile3(ByVal iconv As Integer, ByVal nk As Integer, _
    ByVal eps As Single)
        '結果ﾌｧｲﾙへの出力3
        'iconv･･･収束有無（0:非収束、1:収束）
        'nk･･･計算回数
        'eps･･･誤差率
        Dim aa$
        Dim i, id, ip As Integer
        Dim zbuf(6) As Single

        If KindDPL > 0 Then
            SwK.WriteLine("大変形計算を適用")
            If iconv = 0 Then
                aa$ = "非収束計算回数" + "," + Str(nk)
            Else
                aa$ = "収束計算回数" + "," + Str(nk)
            End If
            SwK.WriteLine(aa$)
            aa$ = "誤差率" + "," + Str(eps)
            SwK.WriteLine(aa$)
            SwK.WriteLine(DotLine$)
        End If
        SwK.WriteLine("＊＊ 変位の出力１ ＊＊")
        SwK.WriteLine("＜節点番号、δX、δY、δZ＞")

        For ip = 1 To NpointC
            i = NvarPSum(Kcomp(ip) - 1)
            For id = 1 To 3
                zbuf(id) = Tf(Lcomp(i + id))
                If Math.Abs(zbuf(id)) > Math.Abs(DispMax(id)) Then
                    DispMax(id) = zbuf(id)
                    KDispMax(id) = ip
                End If
            Next id
            aa$ = Str(ip) + ",  " + Str$(zbuf(1)) + ",  " + Str$(zbuf(2))
            aa$ = aa$ + ",  " + Str$(zbuf(3))
            SwK.WriteLine(aa$)
        Next ip
        SwK.WriteLine("＊＊ 変位の出力２ ＊＊")
        SwK.WriteLine("＜節点番号、θx、θy、θz＞")
        For ip = 1 To NpointC
            If NvarP(Kcomp(ip)) > 3 Then
                i = NvarPSum(Kcomp(ip) - 1)
                For id = 4 To 6
                    zbuf(id) = Tf(Lcomp(i + id))
                    If Math.Abs(zbuf(id)) > Math.Abs(DispMax(id)) Then
                        DispMax(id) = zbuf(id)
                        KDispMax(id) = ip
                    End If
                Next id
                aa$ = Str(ip) + ",  " + Str$(zbuf(1)) + ",  " + Str$(zbuf(2))
                aa$ = aa$ + ",  " + Str$(zbuf(3))
                SwK.WriteLine(aa$)
            End If
        Next ip

    End Sub

    Private Sub ResFile4()
        '結果ﾌｧｲﾙへの出力4
        Dim a1$, a3$, a4$, aa$
        Dim i, j, k As Integer

        a1$ = ""
        SwK.WriteLine(DotLine$)
        aa$ = "＜最大値データ（変位）＞"
        SwK.WriteLine(aa$)
        CalcRes$ = aa$
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        SwK.WriteLine(DotLine$)
        aa$ = "＜最大値データ（変位）＞"
        SwK.WriteLine(aa$)
        CalcRes$ = aa$
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To 6
            Select Case i
                Case 1
                    aa$ = "δX"
                Case 2
                    aa$ = "δY"
                Case 3
                    aa$ = "δZ"
                Case 4
                    aa$ = "θX"
                Case 5
                    aa$ = "θY"
                Case 6
                    aa$ = "θZ"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(DispMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KDispMax(i))
            SwK.WriteLine(aa$)
            If i < 4 Then
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next i

        aa$ = "＜最大値データ（立体要素の応力）＞"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "注）σmax、σminは正負込みの最大、最小。その他は絶対値の最大。"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、  最大値、        節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To 10
            Select Case i
                Case 1
                    aa$ = "σx"
                Case 2
                    aa$ = "σy"
                Case 3
                    aa$ = "σz"
                Case 4
                    aa$ = "τxy"
                Case 5
                    aa$ = "τyz"
                Case 6
                    aa$ = "τzx"
                Case 7
                    aa$ = "σmax"
                Case 8
                    aa$ = "σmin"
                Case 9
                    aa$ = "τmax"
                Case 10
                    aa$ = "σmises"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(StMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KStMax(i))
            SwK.WriteLine(aa$)
            CalcRes$ = CalcRes$ + Cr$ + aa$
        Next i

        aa$ = "＜最大値データ（部材要素の応力・軸力等）＞"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "注）正負の最大、最小。"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、    変数値、         要素番号、   節点番号"
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$

        For i = 0 To 10
            Select Case i
                Case 0
                    a1$ = "軸σf "
                    j = 5
                Case 1
                    a1$ = "軸力 "
                    j = 6
                Case 2
                    a1$ = "剪断ＦyB "
                    j = 2
                Case 3
                    a1$ = "剪断ＦzB "
                    j = 2
                Case 4
                    a1$ = "捩りＭxB "
                    j = 2
                Case 5
                    a1$ = "曲げＭyB "
                    j = 2
                Case 6
                    a1$ = "曲げＭzB "
                    j = 2
                Case 7
                    a1$ = "曲げσb "
                    j = 3
                Case 8
                    a1$ = "合計σA "
                    j = 3
                Case 9
                    a1$ = "剪断τA "
                    j = 3
                Case 10
                    a1$ = "捩りτp "
                    j = 3
            End Select
            For k = 1 To 2
                Select Case k
                    Case 1
                        aa$ = a1$ + "max," + Space(j)
                        a3$ = Str(Zfmax(i))
                        a4$ = Space(16 - Len(a3$))
                        aa$ = aa$ + a3$ + "," + a4$
                        a3$ = Str(KEfmax(i))
                        a4$ = Space(12 - Len(a3$))
                        aa$ = aa$ + a3$ + "," + a4$
                        aa$ = aa$ + Str(KPfmax(i))
                        SwK.WriteLine(aa$)
                        If i = 0 Or i > 6 Then
                            CalcRes$ = CalcRes$ + Cr$ + aa$
                        End If
                    Case 2
                        If i < 9 Then
                            aa$ = a1$ + "min," + Space(j)
                            a3$ = Str(Zfmin(i))
                            a4$ = Space(16 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            a3$ = Str(KEfmin(i))
                            a4$ = Space(12 - Len(a3$))
                            aa$ = aa$ + a3$ + "," + a4$
                            aa$ = aa$ + Str(KPfmin(i))
                            SwK.WriteLine(aa$)
                            SwK.WriteLine(aa$)
                            If i = 0 Or i > 6 Then
                                CalcRes$ = CalcRes$ + Cr$ + aa$
                            End If
                        End If
                End Select
            Next k
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal ub As Double)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'ub･･･拘束値
        Dim it, j, k1, mx As Integer
        If k > 1 Then
            For j = Idiag(k - 1) + 1 To Idiag(k) - 1
                If ub <> 0 Then
                    it = k - Idiag(k) + j
                    Tf(it) = Tf(it) - Tk(j) * ub
                End If
                Tk(j) = 0
            Next j
        End If
        If k < Neff Then
            mx = mb
            If k + mb - 1 > Neff Then
                mx = Neff - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        Tf(it) = Tf(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        Tf(k) = ub

    End Sub

    Private Sub Solver1()
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）
        Dim aa$, timn$
        Dim i, i0, icount, ii, ij, ik, jk, j, j0, jj, jm1, k, kdiv, kk, mi, mij, mj As Integer
        Dim crate, dn, fw0, fwx, riter, rmesh, rsec1, rsec2 As Single
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        rmesh = 0.8
        dn = Neff / 10.0 - 0.001
        riter = dn
        kdiv = 0
        Dim timenew As Date = Now
        rsec1 = TimeLap(Timst, timenew)
        Application.DoEvents()
        icount = 0
        For i = 2 To Neff
            i0 = Idiag(i) - i
            mi = Idiag(i - 1) - i0 + 1
            For j = mi To i
                sum = 0
                j0 = Idiag(j) - j
                mj = 1
                If j > 1 Then
                    mj = Idiag(j - 1) - j0 + 1
                End If
                mij = mi
                If mj > mi Then
                    mij = mj
                End If
                ij = i0 + j
                jm1 = j - 1
                For k = mij To jm1
                    If mij <= jm1 Then
                        ik = i0 + k
                        kk = Idiag(k)
                        jk = j0 + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    End If
                Next k
                If j = i Then
                    ii = i0 + i
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            riter = riter - 1
            If riter <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ1  k=" + Str$(k) + "  "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)
                rmesh = rmesh - 0.06
                crate = 1 - rmesh
                fw0 = Fw1
                fwx = rmesh * Fw1 + crate * Fw2
                If KindDPL = 0 Then
                    ProgressBar1.Value = 100 * fwx / Fw2
                    If kdiv > 0 And kdiv < 9 Then
                        Dim timenew1 As Date = Now
                        rsec2 = TimeLap(Timst, timenew1)
                        rsec2 = rsec2 - rsec1
                        Call ReqTime(crate - 0.23, rmesh, rsec2)
                        '残りの所要時間の計算
                    End If
                End If
                kdiv = kdiv + 1
                riter = dn
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, i0, i1, j, j0, j1, j2, j3, k As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        For i = 2 To Neff
            sum = 0
            i0 = Idiag(i) - i
            j1 = Idiag(i - 1) - i0 + 1
            j2 = i - 1
            If j1 <> i Then
                For j = j1 To j2
                    j0 = i0 + j
                    sum = sum + Tk(j0) * Tf(j)
                Next j
            End If
            Tf(i) = Tf(i) - sum
        Next i

        For i = 1 To Neff
            i1 = Idiag(i)
            If Tk(i1) <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0以下になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            Tf(i) = Tf(i) / Tk(i1)
        Next i

        For k = Neff - 1 To 1 Step -1
            j1 = k + 1
            j2 = j1 + mh - 1
            If j2 > Neff Then
                j2 = Neff
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= k Then
                    j0 = Idiag(j) - j + k
                    sum = sum + Tk(j0) * Tf(j)
                End If
            Next j
            Tf(k) = Tf(k) - sum
        Next k

        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kk, kx, kz, m As Integer
        Dim b1 As Single
        Dim acos(3), aval1(3), aval2(3), csb(3), fsb(3) As Single
        For ib = 1 To NspringC
            If KPspringC(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = NvarPSum(Kcomp(KPspringC(ib, 1)) - 1)
                For j = 1 To 3
                    k = k + 1
                    If Lcomp(k) > 0 Then
                        kk = Idiag(Lcomp(k))
                        Tk(kk) = Tk(kk) - CspringC(ib, j)
                        Tf(Lcomp(k)) = Tf(Lcomp(k)) + FspringC(ib, j)
                    End If
                Next j
            Else  '節点間ﾊﾞﾈ
                k1 = KPspringC(ib, 1)
                k2 = KPspringC(ib, 2)
                aval1(1) = Xdata(k1)
                aval1(2) = Ydata(k1)
                aval1(3) = Zdata(k1)
                aval2(1) = Xdata(k2)
                aval2(2) = Ydata(k2)
                aval2(3) = Zdata(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 3
                    csb(j) = CspringC(ib, 1) * acos(j)
                    fsb(j) = FspringC(ib, 1) * acos(j)
                Next j
                k1 = NvarPSum(Kcomp(k1) - 1)
                k2 = NvarPSum(Kcomp(k2) - 1)
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 3  'XYZ方向
                        k = k + 1
                        kx = Lcomp(k)
                        If kx > 0 Then
                            kk = Idiag(kx)
                            Tk(kk) = Tk(kk) - csb(j) * acos(j)
                            Tf(kx) = Tf(kx) + b1 * fsb(j)
                            If j < 3 Then
                                For jj = j + 1 To 3
                                    kb = k + jj - 1
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) - csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If
                            If m = 1 And k1 < k2 Then   '大きい変数番号の側で記憶
                                For jj = 1 To 3
                                    kb = k2 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            ElseIf m = 2 And k2 < k1 Then
                                For jj = 1 To 3
                                    kb = k1 + jj
                                    kz = Lcomp(kb)
                                    If kz > 0 Then
                                        kk = Idiag(kz) - kz + kx
                                        Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                                    End If
                                Next jj
                            End If

                        End If
                    Next j
                Next m
            End If
        Next ib
    End Sub

    Private Sub Store(ByVal nvarb As Integer)
        '全体ﾏﾄﾘｯｸｽへの蓄積
        'nvarb･･･要素ﾏﾄﾘｯｸｽの次数
        Dim i, it, j, jt, k As Integer
        For i = 1 To nvarb
            it = NPrefer(i)
            If it > 0 Then
                For j = i To nvarb
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it > jt Then
                            k = Idiag(it) - it + jt
                        Else
                            k = Idiag(jt) - jt + it
                        End If
                        Tk(k) = Tk(k) + Ek(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub StressCalc(ByVal mh As Integer)
        '応力計算
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim aa$, timn$
        Dim i, icount, id, ie, ii, ip, isb, istage, j, k, kb As Integer
        Dim b1, e, rnu, sx, sy, sz, txy, tyz, tzx As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "応力 計算中" + "   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Call TrSet(Tr)  '節点応力計算のTr行列の設定
        istage = 1
        For ip = 1 To NpointC
            Nw(ip) = 0
            For isb = 1 To 6
                Tp(ip, isb) = 0
            Next isb
        Next ip
        Application.DoEvents()
        icount = 0
        For ie = 1 To NelemC
            If KindEC(ie) = 0 Then
                j = 0
                For ii = 1 To 20
                    i = NNelemC(ie, ii)
                    k = NvarPSum(Kcomp(i) - 1)
                    For id = 1 To 3
                        j = j + 1
                        k = k + 1
                        Eu(j) = Tf(Lcomp(k))
                    Next id
                Next ii
                Call ElemMatrix(ie, istage, kb, e, rnu)
                '要素ﾏﾄﾘｯｸｽの計算

                For i = 1 To 20
                    For isb = 1 To 6
                        Spoint(i, isb) = 0
                    Next isb
                    For j = 1 To 27
                        b1 = Tr(i, j)
                        For isb = 1 To 6
                            Spoint(i, isb) = Spoint(i, isb) + b1 * Sgaus(j, isb)
                        Next isb
                    Next j
                Next i

                For ii = 1 To 20
                    i = Kcomp(NNelemC(ie, ii))
                    Nw(i) = Nw(i) + 1
                    For isb = 1 To 6
                        Tp(i, isb) = Tp(i, isb) + Spoint(ii, isb)
                    Next isb
                Next ii
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie
        SwK.WriteLine("-----------------------------------------------")
        SwK.WriteLine("＊＊ 立体要素の節点応力の出力 ＊＊")
        aa$ = "＜節点番号、σx、σy、σz、τxy、τyz、τzx、"
        aa$ = aa$ + "σmax、σmin、τmax、σmises＞"
        SwK.WriteLine(aa$)
        Application.DoEvents()
        icount = 0
        For ii = 1 To NpointC
            ip = Kcomp(ii)
            If Nw(ip) > 0 Then
                sx = Tp(ip, 1) / Nw(ip)
                sy = Tp(ip, 2) / Nw(ip)
                sz = Tp(ip, 3) / Nw(ip)
                txy = Tp(ip, 4) / Nw(ip)
                tyz = Tp(ip, 5) / Nw(ip)
                tzx = Tp(ip, 6) / Nw(ip)
                Call StressOut(ii, sx, sy, sz, txy, tyz, tzx)    '応力値の出力
            End If
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ii

    End Sub

    Private Sub StressOut(ByVal ip As Integer, ByVal sx As Double, _
        ByVal sy As Double, ByVal sz As Double, ByVal txy As Double, _
        ByVal tyz As Double, ByVal tzx As Double)
        '応力値の出力
        'ip･･･節点番号
        'sx,sy,sz･･･σx,σy,σz
        'txy,tyz,tzx･･･τxy,τyz,τzx
        Dim aa$
        Dim ic, k As Integer
        Dim b1, b2, b3, s1, s2, sb, smax, smin As Double
        Dim x1, x2, xb, xleft, xright As Double
        Dim zbuf(10) As Single
        Dim cbuf(2) As Double

        zbuf(1) = sx
        zbuf(2) = sy
        zbuf(3) = sz
        zbuf(4) = txy
        zbuf(5) = tyz
        zbuf(6) = tzx

        cbuf(2) = -(sx + sy + sz)
        b1 = sx * sy + sy * sz + sz * sx
        b2 = txy * txy + tyz * tyz + tzx * tzx
        cbuf(1) = b1 - b2
        b1 = sx * sy * sz
        b2 = sx * tyz * tyz + sy * tzx * tzx + sz * txy * txy
        b3 = 2 * txy * tyz * tzx
        cbuf(0) = -(b1 - b2 + b3)
        b1 = cbuf(2) ^ 2 - 3 * cbuf(1)
        b2 = Math.Sqrt(b1)
        x1 = (-cbuf(2) - b2) / 3    '下側の極大点
        x2 = (-cbuf(2) + b2) / 3    '上側の極小点
        smax = sx : smin = sx
        For k = 1 To 5
            Select Case k
                Case 1
                    sb = sy
                Case 2
                    sb = sz
                Case 3
                    sb = txy
                Case 4
                    sb = tyz
                Case 5
                    sb = tzx
            End Select
            If sb > smax Then
                smax = sb
            ElseIf sb < smin Then
                smin = sb
            End If
            If k = 2 Then
                s1 = smin
                s2 = smax
            End If
        Next k
        b1 = smax - smin
        xb = x2
        xleft = x2
        xright = x2 + b1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        zbuf(7) = xb
        xb = x1
        xleft = x1 - b1
        xright = x1
        Call EquaCalc(cbuf, xb, xleft, xright) '3次方程式の計算
        zbuf(8) = xb
        zbuf(9) = 0.5 * (zbuf(7) - zbuf(8))

        'ﾐｰｾﾞｽ応力の計算
        b1 = 0.5 * ((sx - sy) ^ 2 + (sy - sz) ^ 2 + (sz - sx) ^ 2)
        b1 = b1 + 3 * (txy ^ 2 + tyz ^ 2 + tzx ^ 2)
        zbuf(10) = Math.Sqrt(b1)

        aa$ = Str(ip)
        For k = 1 To 10
            aa$ = aa$ + ",  " + Str(zbuf(k))
        Next k
        SwK.WriteLine(aa$)

        If ip = 1 Then
            ic = 1
        Else
            ic = 0
        End If
        For k = 1 To 10
            Select Case k
                Case 7
                    If ic > 0 Or zbuf(7) > StMax(7) Then
                        StMax(7) = zbuf(7)
                        KStMax(7) = ip
                    End If
                Case 8
                    If ic > 0 Or zbuf(8) < StMax(8) Then
                        StMax(8) = zbuf(8)
                        KStMax(8) = ip
                        ic = 0
                    End If
                Case Else
                    If Math.Abs(zbuf(k)) > Math.Abs(StMax(k)) Then
                        StMax(k) = zbuf(k)
                        KStMax(k) = ip
                    End If
            End Select
        Next k

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub CompFEM3Cal5_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim a1$, aa$, timn$
        Dim i, iconv, icount, ie, ik, istage As Integer
        Dim j, k, kb, kh, mb, mbx, nk, nvarb As Integer
        Dim b1, drmesh, eps, freemem, fwx, rmesh, sec As Single
        Dim df, ej, fmax, rnu, ub As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Fw1 = 0 : Fw2 = 100
        Call ResFile1U()     '結果ﾌｧｲﾙへの出力1

        aa$ = "初期設定処理  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Dim xbuf(NpointC), ybuf(NpointC), zbuf(NpointC) As Single
        Call AxisValueTreat(xbuf, ybuf, zbuf)   '座標値の端数処理

        Call PnumImproveNew(mb, mbx, xbuf, ybuf, zbuf)  '節点順序の改良
        Erase xbuf, ybuf, zbuf
        Application.DoEvents()

        Call InitialSet1()  '初期設定1

        Call InitialSet2(mb)  '初期設定2

        Call ResFile2(mb)   '結果ﾌｧｲﾙへの出力2

        Call VCosCalc(kh) '断面ＹB軸の方向余弦計算
        If kh > 0 Then
            End
        End If

        rmesh = 0
        drmesh = 0.8 / NKmax
        For ik = 1 To NKmax
            Call CosCalc()  '部材の方向余弦の計算
            Call LoadSet()  '荷重の設定

            istage = 0 : kb = 0
            Application.DoEvents()
            icount = 0
            For ie = 1 To NelemC
                aa$ = "要素" + Str$(ie) + "   "
                Call TimCal(1, timn$)
                aa$ = aa$ + timn$
                gr.Clear(Color.White)
                gr.DrawString(aa$, fnt, myBrush, 1, 1)

                If KindEC(ie) = 0 Then
                    Call ElemMatrix(ie, istage, kb, ej, rnu)
                    '要素ﾏﾄﾘｯｸｽの計算
                    nvarb = 60
                Else
                    Call ElemMatrixBar(ie, istage)     '要素ﾏﾄﾘｯｸｽの計算
                    If KindEC(ie) = 1 Then
                        nvarb = 6
                    Else
                        nvarb = 12
                    End If
                End If
                Call Store(nvarb)    '全体ﾏﾄﾘｯｸｽへの蓄積
                If icount < 99 Then
                    icount = icount + 1
                Else
                    Application.DoEvents()
                    icount = 0
                End If
            Next ie

            If NspringC > 0 Then
                Call SpringSet()    'バネ支持の設定
            End If

            '進行表示
            rmesh = rmesh + 0.2 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2

            For i = 1 To NBvar
                k = Lcomp(KBfix(i))
                If k > 0 Then
                    ub = VBfix(i)
                    Call RestCond(k, mb, ub)    '拘束条件処理
                End If
            Next i

            Call Solver1()  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            '進行表示
            rmesh = rmesh + 0.8 * drmesh
            fwx = (1 - rmesh) * Fw1 + rmesh * Fw2
            ProgressBar1.Value = 100 * fwx / Fw2
            Dim timenew1 As Date = Now
            sec = TimeLap(Timst, timenew1)
            b1 = 1 - rmesh
            Call ReqTime(rmesh, b1, sec)   '残りの所要時間の計算

            Application.DoEvents()
            If NKmax > 1 Then
                df = 0 : fmax = 0
                For j = 1 To Neff
                    ub = Math.Abs(Tf(j) - Tfx(j))
                    If ub > df Then
                        df = ub
                    End If
                    ub = Math.Abs(Tfx(j))
                    If ub > fmax Then
                        fmax = ub
                    End If
                    Tfx(j) = Tf(j)
                Next j
                If ik > 1 Then
                    eps = df / fmax
                    If eps < EpsCalc Then
                        iconv = 1
                        nk = ik
                        Exit For
                    End If
                End If
                If ik = NKmax Then
                    nk = ik
                    Exit For
                Else
                    For i = 1 To Neff
                        Tf(i) = 0
                    Next i
                    For i = 1 To NumEff
                        Tk(i) = 0
                    Next i

                    Call VCosCalc2()    '断面ＹB軸の方向余弦計算2
                    For ie = 1 To NelemC
                        If KindEC(ie) > 0 Then
                            For j = 1 To 2
                                BarForce(ie, j) = 0
                                BarYShear(ie, j) = 0
                                BarZShear(ie, j) = 0
                                BarYMoment(ie, j) = 0
                                BarZMoment(ie, j) = 0
                            Next j
                        End If
                    Next ie
                End If
            Else
                iconv = 1
                Exit For
            End If
        Next ik

        Me.BringToFront()
        If iconv = 0 Then
            SwK.Close()
            aa$ = "計算が収束しませんでした！"
            aa$ = aa$ + Chr(13) + Chr(10) + "繰返し計算回数" + Str$(nk)
            a1$ = "計算エラー"
        Else
            Call ResFile3(iconv, nk, eps)   '結果ﾌｧｲﾙへの出力3

            Application.DoEvents()
            Call StressCalc(mb) '応力計算

            Call ForceCalc()   '軸力等の計算

            Application.DoEvents()
            Call BForceCalc()   '拘束境界の反力計算

            Application.DoEvents()
            Call ResFile4()     '結果ﾌｧｲﾙへの出力4

            '進行表示
            ProgressBar1.Value = 100

            Call TimCal(1, timn$)
            freemem = Int(FreeMemoryGet() / 1000.0)
            aa$ = "END   " + timn$ + "   " + Str(freemem) + "MB free"
            SwK.WriteLine(aa$)
            SwK.Close()

            Label1.Text = "計算終了！"
            Label2.Text = "計算結果をファイルへ出力しました。"
            Label3.Text = aa$
            aa$ = "計算が終了しました。"
            If KindDPL > 0 Then
                aa$ = aa$ + Cr$ + "繰返し計算回数" + Str$(nk)
            End If
            aa$ = aa$ + Cr$ + CalcRes$
            a1$ = "計算確認"
        End If
        Me.BringToFront()
        If KindBatch = 0 Then
            MsgBox(aa$, 0, a1$)
        Else
            Kfinish = 1
        End If
        gr.Dispose()

        Me.Close()

    End Sub
End Class
